//	+---------------------------+
//	|	Maze Generator			|
//	+---------------------------+
//	|	generate.cs				|
//	+---------------------------+
//	|	Version: 1.0			|
//	|	Released: Jan.9.2014	|
//	|	Author: Zapk | 12270	|
//	+---------------------------+

function mazeString_add(%string)
{
	$Maze::TempString = $Maze::TempString @ %string;
}

function Maze_GetRandomMaximum()
{
	return 327673276732767;
}

function Maze_Generate()
{
	$Maze::TempString = "";
	$Maze::File = "base/server/temp/maze.txt";
	
	if(isFile($Maze::File))
	{
		fileDelete($Maze::File);
	}
	
	%file = new fileObject();
	%file.openForWrite($Maze::File);
	
	$Maze::Width = 14;
	$Maze::Height = 15;
	
	%left[0] = $Maze::Height;
	%height = $Maze::Height;
	
	mazeString_add("Start\n");
	
	%temp_pointer = $Maze::Width;
	for(%i = 0; %temp_pointer-- > -1; %i++)
	{
		mazeString_add((%i != 0) ? "._" : ". ");
		
		%left[%temp_pointer] = %right[%temp_pointer] = %temp_pointer;
	}
	
	mazeString_add(".\n|");
	for(true; %height > 0; %height--)
	{
		for(%cell = $Maze::Width; %cell-- > -1; mazeString_add(%maze[0] @ %maze[1]))
		{
			if((%cell != (%temp_pointer = %left[%cell-1])) && (6 << 26 < getRandom(0, Maze_GetRandomMaximum())))
			{
				%right[%temp_pointer] = %right[%cell];
				%left[%right[%cell]] = %temp_pointer;	
				%right[%cell] = %cell-1;
				%left[%cell-1] = %cell;
				%maze[1] = ".";
			}
			else
			{
				%maze[1] = "|";
			}
			if((%cell != (%temp_pointer = %left[%cell])) && (6 << 26 < getRandom(0, Maze_GetRandomMaximum())))
			{ 
				%right[%temp_pointer] = %right[%cell];
				%left[%right[%cell]] = %temp_pointer;
				%left[%cell] = %cell;		
				%right[%cell] = %cell;
				%maze[0] = "_";	
			}
			else
			{
				%maze[0] = " ";
			}
		}
		mazeString_add("\n|");
	}
	
	%maze[0] = "_";
	for(%cell = $Maze::Width; %cell-- > -1; mazeString_add(%maze[0] @ %maze[1]))
	{
		if((%cell != (%temp_pointer = %left[%cell-1])) && ((%cell == %right[%cell]) || (6 << 26 < getRandom(0, Maze_GetRandomMaximum()))))
		{
			%left[%right[%temp_pointer] = %right[%cell]] = %temp_pointer;
			%left[%right[%cell] = %cell-1] = %cell;
			%maze[1] = ".";
		}
		else
		{
			%maze[0] = (%cell == 0) ? " " : "_";
			%maze[1] = (%cell == 0) ? "|" : ".";
		}
		%temp_pointer = %left[cell];
		%right[%temp_pointer] = %right[%cell];
		%left[%right[%cell]] = %temp_pointer;
		%left[%cell] = %cell;
		%right[%cell] = %cell;
	}
	
	mazeString_add("\n");
	
	for(%cell = $Maze::Width; %cell-- > -1; true)
	{
		mazeString_add((%cell == 0) ? "End" : "  ");
	}
	
	%file.writeLine($Maze::TempString);
	%file.close();
	%file.delete();
}